diff --git a/arch/arm/mach-sa1100/assabet.c b/arch/arm/mach-sa1100/assabet.c
index 2b833aa0212b..3d8aeda35e1b 100644
--- a/arch/arm/mach-sa1100/assabet.c
+++ b/arch/arm/mach-sa1100/assabet.c
@@ -46,6 +46,36 @@
 
 #include "generic.h"
 
+enum {
+	/* System Configuration Register flags */
+	SCR_SDRAM_LOW	= BIT(2),  /* SDRAM size (low bit) */
+	SCR_SDRAM_HIGH	= BIT(3),  /* SDRAM size (high bit) */
+	SCR_FLASH_LOW	= BIT(4),  /* Flash size (low bit) */
+	SCR_FLASH_HIGH	= BIT(5),  /* Flash size (high bit) */
+	SCR_GFX		= BIT(8),  /* Graphics Accelerator (0=present) */
+	SCR_SA1111	= BIT(9),  /* Neponset (0=present) */
+
+	/* GPIOs (bitmasks) for which the generic definition doesn't say much */
+	GPIO_RADIO_IRQ		= GPIO_GPIO(14), /* Radio interrupt request  */
+	GPIO_PS_MODE_SYNC	= GPIO_GPIO(16), /* Power supply mode/sync   */
+	GPIO_STEREO_64FS_CLK	= GPIO_GPIO(19), /* SSP UDA1341 clock input  */
+	GPIO_GFX_IRQ		= GPIO_GPIO(24), /* Graphics IRQ */
+	GPIO_BATT_LOW		= GPIO_GPIO(26), /* Low battery */
+	GPIO_SYS_CLK		= GPIO_GPIO(27),
+};
+
+#ifdef CONFIG_ASSABET_NEPONSET
+#define machine_has_neponset()  ((SCR_value & SCR_SA1111) == 0)
+#else
+#define machine_has_neponset()	(0)
+#endif
+
+/* The build phase of the hardware.  This isn't detectable */
+#define assabet_phase()		4
+
+#define ASSABET_BCR_BASE  0xf1000000
+#define ASSABET_BCR       IOMEM(ASSABET_BCR_BASE)
+
 #define ASSABET_BCR_DB1110 \
 	(ASSABET_BCR_SPK_OFF    | \
 	 ASSABET_BCR_LED_GREEN  | ASSABET_BCR_LED_RED   | \
@@ -59,8 +89,7 @@
 	 ASSABET_BCR_CF_BUS_OFF | ASSABET_BCR_STEREO_LB | \
 	 ASSABET_BCR_IRDA_MD0   | ASSABET_BCR_CF_RST)
 
-unsigned long SCR_value = ASSABET_SCR_INIT;
-EXPORT_SYMBOL(SCR_value);
+static unsigned long SCR_value = ~0UL;
 
 static struct gpio_chip *assabet_bcr_gc;
 
@@ -309,30 +338,26 @@ static struct mcp_plat_data assabet_mcp_data = {
 	.codec_pdata	= &assabet_ucb1x00_data,
 };
 
-static void assabet_lcd_set_visual(u32 visual)
-{
-	u_int is_true_color = visual == FB_VISUAL_TRUECOLOR;
+static struct gpiod_lookup_table assabet_platform_gpio_table = {
+	.table = {
+		GPIO_LOOKUP("assabet", 10, "lcd-depth", GPIO_ACTIVE_HIGH),
+		GPIO_LOOKUP("assabet", 11, "lcd-on", GPIO_ACTIVE_HIGH),
+		{ },
+	},
+};
 
-	if (machine_is_assabet()) {
-#if 1		// phase 4 or newer Assabet's
-		if (is_true_color)
-			ASSABET_BCR_set(ASSABET_BCR_LCD_12RGB);
-		else
-			ASSABET_BCR_clear(ASSABET_BCR_LCD_12RGB);
-#else
-		// older Assabet's
-		if (is_true_color)
-			ASSABET_BCR_clear(ASSABET_BCR_LCD_12RGB);
-		else
-			ASSABET_BCR_set(ASSABET_BCR_LCD_12RGB);
-#endif
-	}
+static struct gpio_desc *gpio_lcd_depth;
+static struct gpio_desc *gpio_lcd_on;
+
+static void assabet_set_visual(u32 visual)
+{
+	gpiod_set_value(gpio_lcd_depth, visual == FB_VISUAL_TRUECOLOR);
 }
 
 #ifndef ASSABET_PAL_VIDEO
 static void assabet_lcd_backlight_power(int on)
 {
-	if (on)
+	if (on && 0)
 		ASSABET_BCR_set(ASSABET_BCR_LIGHT_ON);
 	else
 		ASSABET_BCR_clear(ASSABET_BCR_LIGHT_ON);
@@ -345,11 +370,13 @@ static void assabet_lcd_backlight_power(int on)
  */
 static void assabet_lcd_power(int on)
 {
-	if (on) {
-		ASSABET_BCR_set(ASSABET_BCR_LCD_ON);
-		udelay(500);
-	} else
-		ASSABET_BCR_clear(ASSABET_BCR_LCD_ON);
+	if (on && 0) {
+		msleep(500);
+		gpiod_set_value(gpio_lcd_on, 1);
+		msleep(500);
+	} else {
+		gpiod_set_value(gpio_lcd_on, 0);
+	}
 }
 
 /*
@@ -372,7 +399,7 @@ static struct sa1100fb_mach_info lq039q2ds54_info = {
 
 	.backlight_power = assabet_lcd_backlight_power,
 	.lcd_power = assabet_lcd_power,
-	.set_visual = assabet_lcd_set_visual,
+	.set_visual = assabet_set_visual,
 };
 #else
 static void assabet_pal_backlight_power(int on)
@@ -382,7 +409,6 @@ static void assabet_pal_backlight_power(int on)
 
 static void assabet_pal_power(int on)
 {
-	ASSABET_BCR_clear(ASSABET_BCR_LCD_ON);
 }
 
 static struct sa1100fb_mach_info pal_info = {
@@ -398,7 +424,7 @@ static struct sa1100fb_mach_info pal_info = {
 
 	.backlight_power = assabet_pal_backlight_power,
 	.lcd_power = assabet_pal_power,
-	.set_visual = assabet_lcd_set_visual,
+	.set_visual = assabet_set_visual,
 };
 #endif
 
@@ -411,6 +437,22 @@ static struct resource neponset_resources[] = {
 };
 #endif
 
+static struct gpiod_lookup_table assabet_uda1341_gpio_table = {
+	.dev_id = "uda134x-codec",
+	.table = {
+		GPIO_LOOKUP("assabet", 21, "qmute", GPIO_ACTIVE_HIGH),
+		{ },
+	},
+};
+
+static struct gpiod_lookup_table assabet_audio_gpio_table = {
+	.dev_id = "assabet-asoc",
+	.table = {
+		GPIO_LOOKUP("assabet", 23, "spkr-shtdn", GPIO_ACTIVE_HIGH),
+		{ },
+	},
+};
+
 static struct gpiod_lookup_table assabet_cf_gpio_table = {
 	.dev_id = "sa11x0-pcmcia.1",
 	.table = {
@@ -494,6 +536,7 @@ static const struct gpio_keys_platform_data assabet_keys_pdata = {
 static struct gpiod_lookup_table assabet_uart1_gpio_table = {
 	.dev_id = "sa11x0-uart.1",
 	.table = {
+		GPIO_LOOKUP("assabet", 12, "xcvr-enable", GPIO_ACTIVE_HIGH),
 		GPIO_LOOKUP("assabet", 16, "dtr", GPIO_ACTIVE_LOW),
 		GPIO_LOOKUP("assabet", 17, "rts", GPIO_ACTIVE_LOW),
 		GPIO_LOOKUP("assabet", 25, "dcd", GPIO_ACTIVE_LOW),
@@ -516,11 +559,19 @@ static struct gpiod_lookup_table assabet_uart3_gpio_table = {
 
 static void __init assabet_init(void)
 {
+	/* Assabets earler than Phase4 have an inverted signal */
+	if (assabet_phase() < 4)
+		assabet_platform_gpio_table.table[0].flags = GPIO_ACTIVE_LOW;
+
+	gpiod_add_lookup_table(&assabet_uda1341_gpio_table);
+	gpiod_add_lookup_table(&assabet_audio_gpio_table);
+	gpiod_add_lookup_table(&assabet_platform_gpio_table);
+
 	/*
 	 * Ensure that the power supply is in "high power" mode.
 	 */
-	GPSR = GPIO_GPIO16;
-	GPDR |= GPIO_GPIO16;
+	GPSR = GPIO_PS_MODE_SYNC;
+	GPDR |= GPIO_PS_MODE_SYNC;
 
 	/*
 	 * Ensure that these pins are set as outputs and are driving
@@ -532,19 +583,18 @@ static void __init assabet_init(void)
 	GPDR |= GPIO_SSP_TXD | GPIO_SSP_SCLK | GPIO_SSP_SFRM;
 
 	/*
-	 * Also set GPIO27 as an output; this is used to clock UART3
-	 * via the FPGA and as otherwise has no pullups or pulldowns,
-	 * so stop it floating.
+	 * Also set GPIO27 as an output; this can be used supply an
+	 * external clock via the FPGA and GPIO18 to clock UART3 and
+	 * radio. It has no pullups or pulldowns, so stop it floating.
 	 */
-	GPCR = GPIO_GPIO27;
-	GPDR |= GPIO_GPIO27;
+	GPCR = GPIO_SYS_CLK;
+	GPDR |= GPIO_SYS_CLK;
 
 	/*
 	 * Set up registers for sleep mode.
 	 */
-	PWER = PWER_GPIO0;
-	PGSR = 0;
-	PCFR = 0;
+	PGSR = GPIO_GPIO(17);
+	PCFR = PCFR_OPDE | PCFR_FP;
 	PSDR = 0;
 	PPDR |= PPC_TXD3 | PPC_TXD1;
 	PPSR |= PPC_TXD3 | PPC_TXD1;
@@ -579,11 +629,16 @@ static void __init assabet_init(void)
 	gpiod_add_lookup_table(&assabet_leds_gpio_table);
 	gpio_led_register_device(-1, &assabet_leds_pdata);
 
+	gpio_lcd_depth = gpiod_get(NULL, "lcd-depth", GPIOD_OUT_HIGH);
+	gpio_lcd_on = gpiod_get(NULL, "lcd-on", GPIOD_OUT_LOW);
+	if (!IS_ERR(gpio_lcd_depth) && !IS_ERR(gpio_lcd_on)) {
 #ifndef ASSABET_PAL_VIDEO
-	sa11x0_register_lcd(&lq039q2ds54_info);
+		sa11x0_register_lcd(&lq039q2ds54_info);
 #else
-	sa11x0_register_lcd(&pal_video);
+		sa11x0_register_lcd(&pal_video);
 #endif
+	}
+
 	sa11x0_register_mtd(&assabet_flash_data, assabet_flash_resources,
 			    ARRAY_SIZE(assabet_flash_resources));
 	sa11x0_register_mcp(&assabet_mcp_data);
@@ -637,6 +692,11 @@ static void __init get_assabet_scr(void)
 	SCR_value = scr;
 }
 
+static char neponset_cmdline[] __initdata = "console=ttySA0 "
+"cpufreq=221200 rw root=/dev/mtdblock2 "
+"mtdparts=sa1100:512K(boot),1M(kernel),2560K(initrd),4M(root) "
+"load_ramdisk=1 prompt_ramdisk=0 mem=32M noinitrd initrd=0xc0800000,3M profile=2";
+
 static void __init
 fixup_assabet(struct tag *tags, char **cmdline)
 {
@@ -644,28 +704,16 @@ fixup_assabet(struct tag *tags, char **cmdline)
 	map_sa1100_gpio_regs();
 	get_assabet_scr();
 
-	if (machine_has_neponset())
+	if (machine_has_neponset()) {
 		printk("Neponset expansion board detected\n");
-}
-
-
-static void assabet_uart_pm(struct uart_port *port, u_int state, u_int oldstate)
-{
-	if (port->mapbase == _Ser1UTCR0) {
-		if (state)
-			ASSABET_BCR_clear(ASSABET_BCR_RS232EN);
-		else
-			ASSABET_BCR_set(ASSABET_BCR_RS232EN);
+		*cmdline = neponset_cmdline;
 	}
 }
 
-static struct sa1100_port_fns assabet_port_fns __initdata = {
-	.pm		= assabet_uart_pm,
-};
 
 static struct map_desc assabet_io_desc[] __initdata = {
   	{	/* Board Control Register */
-		.virtual	=  0xf1000000,
+		.virtual	= ASSABET_BCR_BASE,
 		.pfn		= __phys_to_pfn(0x12000000),
 		.length		= 0x00100000,
 		.type		= MT_DEVICE
@@ -687,12 +735,12 @@ static void __init assabet_map_io(void)
 	 * Its called GPCLKR0 in my SA1110 manual.
 	 */
 	Ser1SDCR0 |= SDCR0_SUS;
-	MSC1 = (MSC1 & ~0xffff) |
+	pr_info("MSC1 = 0x%08lx -> 0x%08lx\n", MSC1,
+//	MSC1 = (MSC1 & ~0xffff) |
+		(MSC1 & ~0xffff) |
 		MSC_NonBrst | MSC_32BitStMem |
-		MSC_RdAcc(2) | MSC_WrAcc(2) | MSC_Rec(0);
-
-	if (!machine_has_neponset())
-		sa1100_register_uart_fns(&assabet_port_fns);
+		MSC_RdAcc(2) | MSC_WrAcc(2) | MSC_Rec(0)
+		);
 
 	/*
 	 * When Neponset is attached, the first UART should be
@@ -726,7 +774,7 @@ static void __init assabet_init_irq(void)
 	 *
 	 * This must precede any driver calls to BCR_set() or BCR_clear().
 	 */
-	assabet_init_gpio((void *)&ASSABET_BCR, def_val);
+	assabet_init_gpio(ASSABET_BCR, def_val);
 }
 
 MACHINE_START(ASSABET, "Intel-Assabet")
diff --git a/arch/arm/mach-sa1100/clock.c b/arch/arm/mach-sa1100/clock.c
index e8691921c69a..d40ce6b0ae05 100644
--- a/arch/arm/mach-sa1100/clock.c
+++ b/arch/arm/mach-sa1100/clock.c
@@ -12,7 +12,8 @@
 #include <linux/spinlock.h>
 
 #include <mach/hardware.h>
-#include <mach/generic.h>
+
+#include "generic.h"
 
 static const char * const clk_tucr_parents[] = {
 	"clk32768", "clk3686400",
@@ -66,12 +67,12 @@ static const struct clk_init_data clk_gpio27_init_data __initconst = {
  * Derived from the table 8-1 in the SA1110 manual, the MPLL appears to
  * multiply its input rate by 4 x (4 + PPCR).  This calculation gives
  * the exact rate.  The figures given in the table are the rates rounded
- * to 100kHz.  Stick with sa11x0_getspeed() for the time being.
+ * to 100kHz.
  */
 static unsigned long clk_mpll_recalc_rate(struct clk_hw *hw,
 	unsigned long prate)
 {
-	return sa11x0_getspeed(0) * 1000;
+	return prate * 4 * (4 + (PPCR & 15));
 }
 
 static const struct clk_ops clk_mpll_ops = {
@@ -106,6 +107,9 @@ int __init sa11xx_clk_init(void)
 		return PTR_ERR(hw);
 
 	clk_hw_register_clkdev(hw, "OSTIMER0", NULL);
+	clk_hw_register_clkdev(hw, NULL, "sa11x0-uart.1");
+	clk_hw_register_clkdev(hw, NULL, "sa11x0-uart.2");
+	clk_hw_register_clkdev(hw, NULL, "sa11x0-uart.3");
 
 	hw = kzalloc(sizeof(*hw), GFP_KERNEL);
 	if (!hw)
@@ -123,6 +127,8 @@ int __init sa11xx_clk_init(void)
 	clk_hw_register_clkdev(hw, NULL, "sa11x0-pcmcia.1");
 	clk_hw_register_clkdev(hw, NULL, "1800");
 
+	clk_hw_register_clkdev(hw, NULL, "assabet-asoc");
+
 	hw = clk_hw_register_mux(NULL, "tucr-mux", clk_tucr_parents,
 				 ARRAY_SIZE(clk_tucr_parents), 0,
 				 (void __iomem *)&TUCR, FShft(TUCR_TSEL),
diff --git a/arch/arm/mach-sa1100/collie.c b/arch/arm/mach-sa1100/collie.c
index 466d755d5702..ed4792a50569 100644
--- a/arch/arm/mach-sa1100/collie.c
+++ b/arch/arm/mach-sa1100/collie.c
@@ -182,7 +182,7 @@ static u_int collie_uart_get_mctrl(struct uart_port *port)
 	return ret;
 }
 
-static struct sa1100_port_fns collie_port_fns __initdata = {
+static const struct sa1100_port_fns collie_port_fns __initconst = {
 	.set_mctrl	= collie_uart_set_mctrl,
 	.get_mctrl	= collie_uart_get_mctrl,
 };
diff --git a/arch/arm/mach-sa1100/h3600.c b/arch/arm/mach-sa1100/h3600.c
index 1cfc0b1fa41c..2b26a5c76e13 100644
--- a/arch/arm/mach-sa1100/h3600.c
+++ b/arch/arm/mach-sa1100/h3600.c
@@ -9,6 +9,7 @@
 #include <linux/init.h>
 #include <linux/kernel.h>
 #include <linux/gpio.h>
+#include <linux/platform_device.h>
 
 #include <video/sa1100fb.h>
 
@@ -114,8 +115,59 @@ static void __init h3600_map_io(void)
 	h3xxx_map_io();
 }
 
+static struct gpiod_lookup_table h3600_sleeve_gpio_table = {
+	.dev_id = "ipaq-h3xxx-sleeve",
+	.table = {
+		GPIO_LOOKUP("gpio", H3600_GPIO_OPT_DET,
+			    "option-detect", GPIO_ACTIVE_LOW),
+		GPIO_LOOKUP("htc-egpio", 2, "option-reset", GPIO_ACTIVE_HIGH),
+		GPIO_LOOKUP("htc-egpio", 4, "nvram-on", GPIO_ACTIVE_HIGH),
+		GPIO_LOOKUP("htc-egpio", 5, "option-on", GPIO_ACTIVE_HIGH),
+		{ },
+	},
+};
+
+static struct gpiod_lookup_table h3600_audio_clk_gpio_table = {
+	.dev_id = "ipaq-audio-clk",
+	.table = {
+		GPIO_LOOKUP("gpio", 12, "clk0", GPIO_ACTIVE_HIGH),
+		GPIO_LOOKUP("gpio", 13, "clk1", GPIO_ACTIVE_HIGH),
+		{ },
+	},
+};
+
+static struct platform_device_info h3600_audio_clk_device = {
+	.name = "ipaq-audio-clk",
+	.id = -1,
+};
+
+static struct gpiod_lookup_table h3600_uda134x_gpio_table = {
+	.dev_id = "uda134x-codec",
+	.table = {
+		GPIO_LOOKUP("htc-egpio", 12, "qmute", GPIO_ACTIVE_HIGH),
+		{ },
+	},
+};
+
+static struct gpiod_lookup_table h3600_asoc_gpio_table = {
+	.dev_id = "h3xxx-asoc",
+	.table = {
+		GPIO_LOOKUP("htc-egpio", 3, "audio-reset", GPIO_ACTIVE_HIGH),
+		GPIO_LOOKUP("htc-egpio", 10, "amp-power", GPIO_ACTIVE_HIGH),
+		GPIO_LOOKUP("htc-egpio", 11, "audio-power", GPIO_ACTIVE_HIGH),
+		{ },
+	},
+};
+
 static void __init h3600_mach_init(void)
 {
+	gpiod_add_lookup_table(&h3600_sleeve_gpio_table);
+	gpiod_add_lookup_table(&h3600_audio_clk_gpio_table);
+	gpiod_add_lookup_table(&h3600_uda134x_gpio_table);
+	gpiod_add_lookup_table(&h3600_asoc_gpio_table);
+
+	platform_device_register_full(&h3600_audio_clk_device);
+
 	h3xxx_mach_init();
 
 	sa11x0_register_lcd(&h3600_lcd_info);
diff --git a/arch/arm/mach-sa1100/h3xxx-sleeve.c b/arch/arm/mach-sa1100/h3xxx-sleeve.c
new file mode 100644
index 000000000000..8aef18062e40
--- /dev/null
+++ b/arch/arm/mach-sa1100/h3xxx-sleeve.c
@@ -0,0 +1,486 @@
+#include <linux/ctype.h>
+#include <linux/delay.h>
+#include <linux/gpio/consumer.h>
+#include <linux/interrupt.h>
+#include <linux/mfd/ipaq-micro.h>
+#include <linux/module.h>
+#include <linux/platform_device.h>
+#include <linux/slab.h>
+#include <linux/workqueue.h>
+#include <linux/ipaq-sleeve.h>
+#include <asm/unaligned.h>
+
+#define SLEEVE_NVRAM_POWER_MS 5
+
+enum {
+	MAX_HEADER = 256,
+	TYPE_I = 1,
+	TYPE_II = 2,
+	NO_RESET = 0xffff,
+};
+
+struct ipaq_sleeve_id {
+	struct ipaq_option_id id;
+	const char *description;
+	u8 version;
+	u8 extended_battery;
+	u16 reset_width;
+	u16 reset_wait;
+	u16 skt_type[2];
+	u8 opt_on_ctl;
+	u8 nvram[256];
+};
+
+struct opt_info {
+	struct device *dev;
+	struct delayed_work detect_work;
+	bool detect_disabled;
+	bool sleeve_changed;
+	bool sleeve_present;
+	bool sleeve_wakeup;
+	struct gpio_desc *detect;
+	struct gpio_desc *nvram_on;
+	struct gpio_desc *opt_on;
+	struct gpio_desc *opt_reset;
+
+	struct ipaq_sleeve_id id;
+};
+
+static int ipaq_option_spi_read(void *buf, unsigned int addr, size_t len)
+{
+	struct device *mdev = bus_find_device_by_name(&platform_bus_type, NULL,
+						      "ipaq-h3xxx-micro");
+	struct ipaq_micro *micro;
+	struct ipaq_micro_msg msg;
+
+	memset(buf, 0, len);
+
+	if (!mdev || !mdev->driver)
+		return -EINVAL;
+
+	micro = dev_get_drvdata(mdev);
+	if (!micro)
+		return -EINVAL;
+
+	memset(&msg, 0, sizeof(msg));
+
+	while (len) {
+		size_t this_len = len;
+
+		if (this_len > 8)
+			this_len = 8;
+
+		msg.id = MSG_SPI_READ;
+		msg.tx_len = 3;
+		msg.tx_data[0] = addr;
+		msg.tx_data[1] = addr >> 8;
+		msg.tx_data[2] = this_len;
+
+		ipaq_micro_tx_msg_sync(micro, &msg);
+
+		memcpy(buf, msg.rx_data, msg.rx_len);
+
+		buf += msg.rx_len;
+		len -= msg.rx_len;
+		addr += msg.rx_len;
+	}
+
+	return 0;
+}
+
+static char *ipaq_option_get_string(u8 **ptr, u8 *end)
+{
+	u8 *p = *ptr;
+	unsigned int i;
+
+	for (i = 0; p[i] && &p[i] < end; i++)
+		if (!isprint(p[i]) || &p[i] == end)
+			return NULL;
+
+	*ptr = p + i + 1;
+
+	return kstrndup(p, i, GFP_KERNEL);
+}
+
+static u8 *ipaq_option_get_ptr(u8 **ptr, u8 *end, size_t size)
+{
+	u8 *p = *ptr;
+
+	if (p - end < size)
+		return NULL;
+
+	*ptr += size;
+
+	return p;
+}
+
+static u8 ipaq_option_get_u8(u8 **ptr, u8 *end)
+{
+	u8 *p = ipaq_option_get_ptr(ptr, end, 1);
+	return p ? *p : 0;
+}
+
+static u16 ipaq_option_get_le16(u8 **ptr, u8 *end)
+{
+	u8 *p = ipaq_option_get_ptr(ptr, end, 2);
+	return p ? get_unaligned_le16(p) : 0;
+}
+
+static u32 ipaq_option_get_le32(u8 **ptr, u8 *end)
+{
+	u8 *p = ipaq_option_get_ptr(ptr, end, 4);
+	return p ? get_unaligned_le32(p) : 0;
+}
+
+static int ipaq_option_read_id(struct opt_info *opt, struct ipaq_sleeve_id *id)
+{
+	unsigned int length;
+	u8 header[5], *ptr, *end;
+	int ret;
+
+	/* Enable the CF bus */
+	gpiod_set_value_cansleep(opt->nvram_on, 1);
+
+	/* Wait for power to stabilise */
+	msleep(SLEEVE_NVRAM_POWER_MS);
+
+	/* Read the first few bytes from the NVRAM */
+	ret = ipaq_option_spi_read(header, 0, sizeof(header));
+	if (ret)
+		goto err;
+
+	ptr = header;
+	end = header + sizeof(header);
+	if (ipaq_option_get_u8(&ptr, end) != 0xaa) {
+		dev_err(opt->dev, "invalid ID structure\n");
+		ret = -EINVAL;
+		goto err;
+	}
+
+	length = ipaq_option_get_le32(&ptr, end);
+	if (length < sizeof(header) || length >= MAX_HEADER - 1) {
+		dev_err(opt->dev, "invalid ID length\n");
+		ret = -EINVAL;
+		goto err;
+	}
+
+	/* Read the full NVRAM contents */
+	ret = ipaq_option_spi_read(id->nvram, 0, length + 1);
+	if (ret)
+		goto err;
+
+	/* reset the pointer */
+	ptr = id->nvram + (ptr - header);
+	end = ptr + length + 1;
+
+	id->version = ipaq_option_get_u8(&ptr, end);
+	id->id.vendor = ipaq_option_get_le16(&ptr, end);
+	id->id.device = ipaq_option_get_le16(&ptr, end);
+
+	id->description = ipaq_option_get_string(&ptr, end);
+	if (!id->description) {
+		ret = -ENOMEM;
+		goto err;
+	}
+
+	ipaq_option_get_ptr(&ptr, end, 2); /* two reserved bytes */
+	id->extended_battery = ipaq_option_get_u8(&ptr, end);
+	ipaq_option_get_ptr(&ptr, end, 2); /* two reserved bytes */
+	id->reset_width = ipaq_option_get_le16(&ptr, end);
+	id->reset_wait = ipaq_option_get_le16(&ptr, end);
+	ipaq_option_get_le16(&ptr, end); /* bootstrap */
+	ipaq_option_get_le16(&ptr, end); /* OEM table */
+
+	if (id->version == TYPE_II) {
+		id->skt_type[0] = ipaq_option_get_le16(&ptr, end);
+		id->skt_type[1] = ipaq_option_get_le16(&ptr, end);
+		id->opt_on_ctl = ipaq_option_get_u8(&ptr, end);
+	} else {
+		id->skt_type[0] = 0;
+		id->skt_type[1] = 0;
+		id->opt_on_ctl = 1;
+	}
+
+	if (ipaq_option_get_le32(&ptr, end) != 0x0f0f0f0f) {
+		dev_err(opt->dev, "missing ID terminator\n");
+		ret = -EINVAL;
+		goto err;
+	}
+
+ err:
+	gpiod_set_value_cansleep(opt->nvram_on, 0);
+	return ret;
+}
+
+static void __ipaq_option_power_on(struct opt_info *opt, bool noirq)
+{
+	gpiod_set_value(opt->opt_reset, 1);
+	gpiod_set_value(opt->opt_on, 1);
+
+	if (opt->id.reset_wait != NO_RESET) {
+		if (noirq)
+			mdelay(opt->id.reset_width);
+		else
+			msleep(opt->id.reset_width);
+	}
+
+	gpiod_set_value(opt->opt_reset, 0);
+
+	if (opt->id.reset_wait != NO_RESET) {
+		if (noirq)
+			mdelay(opt->id.reset_wait);
+		else
+			msleep(opt->id.reset_wait);
+	}
+}
+
+static void ipaq_option_power_on(struct opt_info *opt)
+{
+	__ipaq_option_power_on(opt, false);
+}
+
+static void ipaq_option_power_off(struct opt_info *opt, bool noirq)
+{
+	gpiod_set_value(opt->opt_reset, 1);
+	gpiod_set_value(opt->opt_on, 0);
+}
+
+static void ipaq_option_insert(struct opt_info *opt)
+{
+	int ret;
+
+	ret = ipaq_option_read_id(opt, &opt->id);
+	if (ret)
+		return;
+
+	dev_info(opt->dev, "%s sleeve inserted\n", opt->id.description);
+
+	if (opt->id.opt_on_ctl)
+		ipaq_option_power_on(opt);
+
+	if (!opt->sleeve_present)
+		ipaq_option_device_add(opt->dev, opt->id.id,
+				       opt->id.description);
+	opt->sleeve_present = true;
+}
+
+static void ipaq_option_remove(struct opt_info *opt)
+{
+	if (opt->sleeve_present)
+		ipaq_option_device_del();
+	opt->sleeve_present = false;
+
+	ipaq_option_power_off(opt, false);
+
+	kfree(opt->id.description);
+	memset(&opt->id, 0, sizeof(opt->id));
+}
+
+static void ipaq_option_work(struct work_struct *work)
+{
+	struct opt_info *opt = container_of(work, struct opt_info, detect_work.work);
+	int present = gpiod_get_value_cansleep(opt->detect);
+
+	if (opt->sleeve_changed)
+		ipaq_option_remove(opt);
+
+	if (present)
+		ipaq_option_insert(opt);
+	else
+		ipaq_option_remove(opt);
+}
+
+static irqreturn_t ipaq_option_irq(int irq, void *data)
+{
+	struct opt_info *opt = data;
+
+	dev_info(opt->dev, "irq: option pack: %u\n", gpiod_get_value(opt->detect));
+
+	if (!opt->detect_disabled)
+		mod_delayed_work(system_wq, &opt->detect_work,
+				 msecs_to_jiffies(100));
+
+	return IRQ_HANDLED;
+}
+
+static int ipaq_h3xxx_sleeve_probe(struct platform_device *pdev)
+{
+	struct device *dev = &pdev->dev;
+	struct opt_info *opt;
+	int irq, ret;
+
+	opt = devm_kzalloc(dev, sizeof(*opt), GFP_KERNEL);
+	if (!opt)
+		return -ENOMEM;
+
+	platform_set_drvdata(pdev, opt);
+	opt->dev = dev;
+	INIT_DELAYED_WORK(&opt->detect_work, ipaq_option_work);
+
+	opt->nvram_on = devm_gpiod_get(dev, "nvram-on", GPIOD_OUT_LOW);
+	if (IS_ERR(opt->nvram_on))
+		return PTR_ERR(opt->nvram_on);
+
+	opt->opt_on = devm_gpiod_get(dev, "option-on", GPIOD_OUT_LOW);
+	if (IS_ERR(opt->opt_on))
+		return PTR_ERR(opt->opt_on);
+
+	opt->opt_reset = devm_gpiod_get(dev, "option-reset", GPIOD_OUT_LOW);
+	if (IS_ERR(opt->opt_reset))
+		return PTR_ERR(opt->opt_reset);
+
+	opt->detect = devm_gpiod_get_optional(dev, "option-detect", GPIOD_IN);
+	if (IS_ERR(opt->detect))
+		return PTR_ERR(opt->detect);
+
+	if (opt->detect) {
+		irq = gpiod_to_irq(opt->detect);
+		if (irq < 0)
+			return irq;
+
+		ret = devm_request_irq(dev, irq, ipaq_option_irq,
+					IRQF_TRIGGER_RISING | IRQF_TRIGGER_FALLING,
+					dev_name(dev), opt);
+		if (ret)
+			return ret;
+	}
+
+	schedule_delayed_work(&opt->detect_work, 0);
+	flush_delayed_work(&opt->detect_work);
+
+	device_set_wakeup_capable(dev, true);
+	device_set_wakeup_enable(dev, false);
+
+	return 0;
+}
+
+static int ipaq_h3xxx_sleeve_remove(struct platform_device *pdev)
+{
+	struct opt_info *opt = platform_get_drvdata(pdev);
+
+	opt->detect_disabled = true;
+	cancel_delayed_work_sync(&opt->detect_work);
+
+	ipaq_option_remove(opt);
+
+	return 0;
+}
+
+static int ipaq_h3xxx_check_wakeup(struct device *dev, void *data)
+{
+	if (device_may_wakeup(dev))
+		return 1;
+
+	return device_for_each_child(dev, data, ipaq_h3xxx_check_wakeup);
+}
+
+static int ipaq_h3xxx_sleeve_suspend(struct device *dev)
+{
+	struct opt_info *opt = dev_get_drvdata(dev);
+	int may_wakeup;
+
+	opt->detect_disabled = true;
+	cancel_delayed_work_sync(&opt->detect_work);
+
+	/* Disable sleeve power if device isn't a wakeup source */
+	may_wakeup = device_for_each_child(dev, NULL, ipaq_h3xxx_check_wakeup);
+
+	opt->sleeve_wakeup = may_wakeup;
+
+	if (device_may_wakeup(dev))
+		enable_irq_wake(gpiod_to_irq(opt->detect));
+
+	return 0;
+}
+
+static int ipaq_h3xxx_sleeve_suspend_noirq(struct device *dev)
+{
+	struct opt_info *opt = dev_get_drvdata(dev);
+
+	if (!opt->sleeve_wakeup && opt->sleeve_present) {
+		ipaq_option_power_off(opt, true);
+
+		/*
+		 * Give the power time to collapse before bringing the
+		 * reset signal to logic 0.
+		 */
+		mdelay(1);
+		gpiod_set_raw_value(opt->opt_reset, 0);
+	}
+
+	return 0;
+}
+
+static int ipaq_h3xxx_sleeve_resume_noirq(struct device *dev)
+{
+	struct opt_info *opt = dev_get_drvdata(dev);
+
+	if (!opt->sleeve_wakeup && gpiod_get_value(opt->detect)) {
+		/*
+		 * We can't check the ID of the sleeve here, so assume that
+		 * it is the same sleeve inserted, and power it up.  This
+		 * avoids an eject/insert cycle on any inserted PCMCIA card.
+		 */
+		__ipaq_option_power_on(opt, true);
+	}
+
+	return 0;
+}
+
+static int ipaq_h3xxx_sleeve_resume(struct device *dev)
+{
+	struct opt_info *opt = dev_get_drvdata(dev);
+	struct ipaq_sleeve_id id;
+	int ret;
+
+	if (device_may_wakeup(dev))
+		disable_irq_wake(gpiod_to_irq(opt->detect));
+
+	if (opt->sleeve_present && gpiod_get_value_cansleep(opt->detect)) {
+		memset(&id, 0, sizeof(id));
+		ret = ipaq_option_read_id(opt, &id);
+		if (ret) {
+			dev_warn(opt->dev, "unable to read sleeve id: %d\n",
+				 ret);
+			opt->sleeve_changed = true;
+			goto finish;
+		}
+
+		if (memcmp(opt->id.nvram, id.nvram, sizeof(id.nvram))) {
+			/* sleeve changed */
+			dev_warn(opt->dev, "sleeve changed\n");
+			opt->sleeve_changed = true;
+		} else {
+			opt->detect_disabled = false;
+			return 0;
+		}
+	}
+
+finish:
+	opt->detect_disabled = false;
+	schedule_delayed_work(&opt->detect_work, 0);
+	flush_delayed_work(&opt->detect_work);
+
+	return 0;
+}
+
+static struct dev_pm_ops ipaq_h3xxx_sleeve_pm = {
+	SET_NOIRQ_SYSTEM_SLEEP_PM_OPS(ipaq_h3xxx_sleeve_suspend_noirq,
+				      ipaq_h3xxx_sleeve_resume_noirq)
+	SET_SYSTEM_SLEEP_PM_OPS(ipaq_h3xxx_sleeve_suspend,
+				ipaq_h3xxx_sleeve_resume)
+};
+
+static struct platform_driver ipaq_h3xxx_sleeve = {
+	.driver = {
+		.name = "ipaq-h3xxx-sleeve",
+		.pm = &ipaq_h3xxx_sleeve_pm,
+	},
+	.probe = ipaq_h3xxx_sleeve_probe,
+	.remove = ipaq_h3xxx_sleeve_remove,
+};
+
+module_platform_driver(ipaq_h3xxx_sleeve);
+
+MODULE_ALIAS("platform:ipaq-h3xxx-sleeve");
+MODULE_LICENSE("GPL");
diff --git a/arch/arm/mach-sa1100/h3xxx.c b/arch/arm/mach-sa1100/h3xxx.c
index d685f03f51f3..9a44a31626b9 100644
--- a/arch/arm/mach-sa1100/h3xxx.c
+++ b/arch/arm/mach-sa1100/h3xxx.c
@@ -83,45 +83,16 @@ static struct resource h3xxx_flash_resource =
 /*
  * H3xxx uart support
  */
-static void h3xxx_uart_pm(struct uart_port *port, u_int state, u_int oldstate)
-{
-	if (port->mapbase == _Ser3UTCR0) {
-		if (!gpio_request(H3XXX_EGPIO_RS232_ON, "RS232 transceiver")) {
-			gpio_direction_output(H3XXX_EGPIO_RS232_ON, !state);
-			gpio_free(H3XXX_EGPIO_RS232_ON);
-		} else {
-			pr_err("%s: can't request H3XXX_EGPIO_RS232_ON\n",
-				__func__);
-		}
-	}
-}
-
-/*
- * Enable/Disable wake up events for this serial port.
- * Obviously, we only support this on the normal COM port.
- */
-static int h3xxx_uart_set_wake(struct uart_port *port, u_int enable)
-{
-	int err = -EINVAL;
-
-	if (port->mapbase == _Ser3UTCR0) {
-		if (enable)
-			PWER |= PWER_GPIO23 | PWER_GPIO25; /* DCD and CTS */
-		else
-			PWER &= ~(PWER_GPIO23 | PWER_GPIO25); /* DCD and CTS */
-		err = 0;
-	}
-	return err;
-}
-
-static struct sa1100_port_fns h3xxx_port_fns __initdata = {
-	.pm		= h3xxx_uart_pm,
-	.set_wake	= h3xxx_uart_set_wake,
+static const struct sa1100_port_fns h3xxx_port_fns __initconst = {
+	.wake		= {
+		[0] = SA11X0_WAKE_CTS | SA11X0_WAKE_DCD,
+	},
 };
 
 static struct gpiod_lookup_table h3xxx_uart3_gpio_table = {
 	.dev_id = "sa11x0-uart.3",
 	.table = {
+		GPIO_LOOKUP("htc-egpio", 7, "xcvr-enable", GPIO_ACTIVE_HIGH),
 		GPIO_LOOKUP("gpio", H3XXX_GPIO_COM_DCD, "dcd", GPIO_ACTIVE_LOW),
 		GPIO_LOOKUP("gpio", H3XXX_GPIO_COM_CTS, "cts", GPIO_ACTIVE_LOW),
 		GPIO_LOOKUP("gpio", H3XXX_GPIO_COM_RTS, "rts", GPIO_ACTIVE_LOW),
@@ -212,10 +183,16 @@ struct platform_device h3xxx_micro_asic = {
 	.num_resources = ARRAY_SIZE(h3xxx_micro_resources),
 };
 
+static struct platform_device h3xxx_sleeve = {
+	.name = "ipaq-h3xxx-sleeve",
+	.id = -1,
+};
+
 static struct platform_device *h3xxx_devices[] = {
 	&h3xxx_egpio,
 	&h3xxx_keys,
 	&h3xxx_micro_asic,
+	&h3xxx_sleeve,
 };
 
 static struct gpiod_lookup_table h3xxx_pcmcia_gpio_table = {
@@ -233,9 +210,22 @@ static struct gpiod_lookup_table h3xxx_pcmcia_gpio_table = {
 	},
 };
 
+static struct gpiod_lookup_table h3xxx_pcmcia_socket0_gpio_table = {
+	.dev_id = "sa11x0-pcmcia",
+	.table = {
+		GPIO_LOOKUP("gpio", H3XXX_GPIO_PCMCIA_CD0,
+			    "detect", GPIO_ACTIVE_LOW),
+		GPIO_LOOKUP("gpio", H3XXX_GPIO_PCMCIA_IRQ0,
+			    "ready", GPIO_ACTIVE_HIGH),
+		GPIO_LOOKUP("htc-gpio", 1, "reset", GPIO_ACTIVE_HIGH),
+		{ },
+	},
+};
+
 void __init h3xxx_mach_init(void)
 {
 	gpiod_add_lookup_table(&h3xxx_pcmcia_gpio_table);
+	gpiod_add_lookup_table(&h3xxx_pcmcia_socket0_gpio_table);
 	gpiod_add_lookup_table(&h3xxx_uart3_gpio_table);
 	sa1100_register_uart_fns(&h3xxx_port_fns);
 	sa11x0_register_mtd(&h3xxx_flash_data, &h3xxx_flash_resource, 1);
diff --git a/arch/arm/mach-sa1100/include/mach/assabet.h b/arch/arm/mach-sa1100/include/mach/assabet.h
index 641a961653af..2022fcae7791 100644
--- a/arch/arm/mach-sa1100/include/mach/assabet.h
+++ b/arch/arm/mach-sa1100/include/mach/assabet.h
@@ -13,31 +13,8 @@
 #ifndef __ASM_ARCH_ASSABET_H
 #define __ASM_ARCH_ASSABET_H
 
-
-/* System Configuration Register flags */
-
-#define ASSABET_SCR_SDRAM_LOW	(1<<2)	/* SDRAM size (low bit) */
-#define ASSABET_SCR_SDRAM_HIGH	(1<<3)	/* SDRAM size (high bit) */
-#define ASSABET_SCR_FLASH_LOW	(1<<4)	/* Flash size (low bit) */
-#define ASSABET_SCR_FLASH_HIGH	(1<<5)	/* Flash size (high bit) */
-#define ASSABET_SCR_GFX		(1<<8)	/* Graphics Accelerator (0 = present) */
-#define ASSABET_SCR_SA1111	(1<<9)	/* Neponset (0 = present) */
-
-#define ASSABET_SCR_INIT	-1
-
-extern unsigned long SCR_value;
-
-#ifdef CONFIG_ASSABET_NEPONSET
-#define machine_has_neponset()  ((SCR_value & ASSABET_SCR_SA1111) == 0)
-#else
-#define machine_has_neponset()	(0)
-#endif
-
 /* Board Control Register */
 
-#define ASSABET_BCR_BASE  0xf1000000
-#define ASSABET_BCR (*(volatile unsigned int *)(ASSABET_BCR_BASE))
-
 #define ASSABET_BCR_CF_PWR	(1<<0)	/* Compact Flash Power (1 = 3.3v, 0 = off) */
 #define ASSABET_BCR_CF_RST	(1<<1)	/* Compact Flash Reset (1 = power up reset) */
 #define ASSABET_BCR_NGFX_RST	(1<<1)	/* Graphics Accelerator Reset (0 = hold reset) */
@@ -75,25 +52,4 @@ extern void assabet_uda1341_reset(int set);
 #define ASSABET_BCR_set(x)	ASSABET_BCR_frob((x), (x))
 #define ASSABET_BCR_clear(x)	ASSABET_BCR_frob((x), 0)
 
-#define ASSABET_BSR_BASE	0xf1000000
-#define ASSABET_BSR (*(volatile unsigned int*)(ASSABET_BSR_BASE))
-
-#define ASSABET_BSR_RS232_VALID	(1 << 24)
-#define ASSABET_BSR_COM_DCD	(1 << 25)
-#define ASSABET_BSR_COM_CTS	(1 << 26)
-#define ASSABET_BSR_COM_DSR	(1 << 27)
-#define ASSABET_BSR_RAD_CTS	(1 << 28)
-#define ASSABET_BSR_RAD_DSR	(1 << 29)
-#define ASSABET_BSR_RAD_DCD	(1 << 30)
-#define ASSABET_BSR_RAD_RI	(1 << 31)
-
-
-/* GPIOs (bitmasks) for which the generic definition doesn't say much */
-#define ASSABET_GPIO_RADIO_IRQ		GPIO_GPIO (14)	/* Radio interrupt request  */
-#define ASSABET_GPIO_PS_MODE_SYNC	GPIO_GPIO (16)	/* Power supply mode/sync   */
-#define ASSABET_GPIO_STEREO_64FS_CLK	GPIO_GPIO (19)	/* SSP UDA1341 clock input  */
-#define ASSABET_GPIO_GFX_IRQ		GPIO_GPIO (24)	/* Graphics IRQ */
-#define ASSABET_GPIO_BATT_LOW		GPIO_GPIO (26)	/* Low battery */
-#define ASSABET_GPIO_RCLK		GPIO_GPIO (26)	/* CCLK/2  */
-
 #endif
